!zone resident {
!src "../music.inc"
!src "config.inc"
!convtab pet
!cpu 6510

;loader zp-addresses
.barrier	= BITFIRE_ZP_ADDR + 0
.filenum	= .barrier

;depacker zp-addresses
.lz_bits	= BITFIRE_ZP_ADDR + 1
.lz_dst		= BITFIRE_ZP_ADDR + 2
.lz_match	= BITFIRE_ZP_ADDR + 4

;define that label here, to not collect labels from installer too
bitfire_install_ = BITFIRE_INSTALLER_ADDR

!if BITFIRE_INCLUDE_DECOMP = 0 {
bitfire_load_addr_hi = .filenum			;in case of no loadcompd, store the highbyte of loadaddress separatedly
}

		* = BITFIRE_RESIDENT_ADDR

!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_frame_count
		!word 0
}

!if BITFIRE_NMI_GAPS = 1 {
!align 255,2
		nop
		nop
		nop
		nop
		nop
		nop
}

!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_player
		pha
		txa
		pha
		tya
		pha
		inc $01				;should be save with $01 == $34/$35, except when music is @ >= $e000
		dec $d019
		jsr link_music_play
		dec $01
		pla
		tay
		pla
		tax
		pla
		rti

!if BITFIRE_INCLUDE_DECOMP = 1 {
;		;expect $01 to be $35
link_load_next_double
		;loads a splitted file, first part up to $d000 second part under IO
		jsr link_load_next_comp
link_load_next_raw_decomp
		jsr link_load_next_raw
		dec $01				;bank out IO
		jsr link_decomp			;depack
		inc $01				;bank in again
		rts
}

}

bitfire_send_byte_
		sec				;insert bit as counter
		ror				;fetch first bit and set marker bit
		sta .filenum			;save value
		ldx #$3f			;start value, is also our mask
		txa
.bit_loop
		and #$2f			;clear bit 4
		adc #$20			;toggle bit 5 and set bit 4 depending on carry -> adc #$20/21
		ora #$0f			;set all lower bits again for next round

		sax $dd02			;only write out lower 6 bits
		nop				;waste cycles so the floppy can keep up
		lsr <(.filenum-$3f),x		;fetch next bit from filenumber and waste cycles
		bne .bit_loop			;last bit?
		stx $dd02			;all lines low again
		rts

!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_load_next_raw
		lda #BITFIRE_LOAD_NEXT
link_load_raw
}

bitfire_loadraw_
		jsr bitfire_send_byte_		;easy, open...
!if BITFIRE_INCLUDE_DECOMP = 1 {
.lz_pollloop
-
		jsr .pollblock
		bcc -
;		rts				;just run into pollblock code again that will then jump to .poll_end and rts
}
.pollblock
		lda $dd00
		anc #$c0			;focus on bit 7 and 6 and copy bit 7 to carry (set if floppy is idle/eof is reached)
		bne .poll_end			;if loadraw only is enabled, skip the blockfetch part and loop
.poll_start
		lda #$60			;set rts
		jsr .bitfire_ack_		;signal that we accept data and communication direction, by basically sending 2 atn strobes by fetching a bogus byte (6 bits could also be used for status? (first two bits might be broken)) also sets an rts in receive loop

		bpl .skip_load_addr		;#$fc -> first block, all positive numbers = delta for barrier << 2

		jsr .get_one_byte		;fetch loadaddr hi
		sta bitfire_load_addr_hi

!if BITFIRE_INCLUDE_DECOMP = 1 {		;decompressor only needs to be setup if there
		sta .barrier			;initial barrier position = loadaddr_hi
		;sta .bitfire_lz_sector_ptr1 + 1
		sta .bitfire_lz_sector_ptr2 + 1
		sta .bitfire_lz_sector_ptr3 + 1
}
		jsr .get_one_byte		;fetch blockaddr lo
		sta bitfire_load_addr_lo	;destination lowbyte

!if BITFIRE_INCLUDE_DECOMP = 1 {		;decompressor only needs to be setup if there
		sta .bitfire_lz_sector_ptr1	;set initial pointers
		sta .bitfire_lz_sector_ptr2
		sta .bitfire_lz_sector_ptr3
		bcc +
.skip_load_addr
		lsr				;lower two bits always cleared, can ommit clc
		lsr
		adc .barrier
		sta .barrier
+
} else {
.skip_load_addr
}

.bitfire_load_block
		jsr .get_one_byte		;fetch blockaddr hi
		sta .bitfire_block_addr_hi	;where to place the block?

		jsr .get_one_byte		;fetch blocklen
		tax
		lda #$a2			;ldy #imm
.bitfire_ack_
		sta .blockpos
		ldy #$37
.get_one_byte
bitfire_ntsc_fix1				;ntsc fix will be done on those labels by installer (opcode $xxxx-$37,x)
		lda $dd00
		sty $dd02
		lsr
		lsr
		stx .blockpos+1			;store initial y, and in further rounds do bogus writes with correct y value anyway, need to waste 4 cycles, so doesn't matter. Saves a byte (tay + sty .blockpos+1) copared to sta .blockpos+1 + nop + nop.
		ldx #$3f

bitfire_ntsc_fix2
		ora $dd00
		stx $dd02
		lsr
		lsr
		dec .blockpos+1			;waste 6 cycles and decrement

bitfire_ntsc_fix3
		ora $dd00			;now ATN is 0 and ora can happen without killing bit 3
		sty $dd02
		lsr
		asr #$7e			;clear carry for free
		sta .nibble + 1
		lda #$c0

bitfire_ntsc_fix4
		and $dd00
		stx $dd02
.nibble		ora #$00			;also adc could be used, or sbc -nibble?
.blockpos	ldx #$00
.bitfire_block_addr_hi = * + 2
bitfire_load_addr_lo = * + 1
		sta $b00b,x
		bne .get_one_byte		;74 cycles per loop

!if >* != >.get_one_byte { !error "getloop code crosses page!" }
.poll_end
!if BITFIRE_INCLUDE_DECOMP = 0 {
		bcc .pollblock
}
		rts				;XXX TODO, could be omitted, following code would not hurt if run

!if BITFIRE_INCLUDE_DECOMP = 1 {
;---------------------------------------------------------------------------------
; REFILL ROUTINES
;---------------------------------------------------------------------------------

.lz_refill_bits
.bitfire_lz_sector_ptr1	= * + 1
bitfire_load_addr_hi = * + 2
		ldy $beef,x
		sty .lz_bits
		rol .lz_bits
		inx
		bne .lz_same_page

.lz_next_page					;/!\ ATTENTION things entered here as well during depacking
		inc .bitfire_lz_sector_ptr1 + 1
		inc .bitfire_lz_sector_ptr2 + 1
		inc .bitfire_lz_sector_ptr3 + 1

.lz_skip_fetch
		php				;turned into a rts in case of standalone decomp
		pha				;preserve Z, carry, A and Y, needed depending on call
		tya
		pha
.lz_fetch_loop
.lz_fetch_sector				;entry of loop
		jsr .pollblock			;fetch another block, returns with x = 0
		bcs .lz_fetch_eof		;eof? yes, finish
		lda .bitfire_lz_sector_ptr1 + 1	;get current depack position
		cmp .barrier			;next pending block/barrier reached?
		bcs .lz_fetch_loop		;already reached, loop
.lz_fetch_eof					;not reached, go on depacking
		pla				;restore regs + flags
		tay
		pla
		plp
.lz_same_page
		rts				;avoid target out of range for branch to .lz_end_of_file

!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_load_next_comp
		lda #BITFIRE_LOAD_NEXT
link_load_comp
}

bitfire_loadcomp_
		jsr bitfire_send_byte_
		lda #$08			;enable pollblock/fetch_sector calls (php)
		ldy #.lz_poll-.lz_skip_poll-2	;currently ldy #$09
		ldx #$ff			;force to load a new sector upon first read, first read is a bogus read and will be stored on lz_bits, second read is then the really needed data
		bne .loadcompd_entry		;load + decomp file

!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_chip_types
link_sid_type			;%00000001
link_cia1_type			;%00000010
link_cia2_type			;%00000100
		!byte $00
}

!if BITFIRE_NMI_GAPS = 1 {
.lz_gap2
						;jmp will be placed here
!align 255,5
!if * - .lz_gap2 < 3 {
	!error "too few bytes left for second gap :-("
}
}

bitfire_decomp_
.lz_end_of_file	= * + 1				;point to rts, this is always reachable \o/
		lda #$60			;disable calls
		ldy #.lz_skip_end-.lz_skip_poll-2
		ldx #$00			;start with first byte of block
.loadcompd_entry
		sta .lz_skip_fetch
		sty .lz_skip_poll + 1
		;load_addr is already set by loadraw_/pollblock

;---------------------------------------------------------------------------------
; DECRUNCHER
;---------------------------------------------------------------------------------


		;******** Start the next match/literal run ********
.lz_decrunch
!if BITFIRE_NO_OVERLAP = 0 {
-
		jsr .lz_refill_bits		;fetch depack addr
		sty .lz_dst-1,x			;x = 0, x = 1 and x = 2
		cpx #$02
		bne -
} else {
-
		tya				;copy previous Y to A for later use
		jsr .lz_refill_bits		;fetch depack addr and end addr, preserves A
		sty .lz_dst-1,x			;x = 0 .. x = 4
		cpx #$04			;fetch 2 more bytes
		bne -
		sta .lz_end_low+1		;a = previous fetched byte
		sty .lz_end_hi+1		;y = last fetched byte
}
		;sec				;set for free by last compare
.lz_type_refill	jsr .lz_refill_bits		;refill bit buffer .lz_bits
.lz_type_check
		bcc .lz_do_match
		beq .lz_type_refill		;we will fall through on entry

		;******** Process literal run ********

		lda #$00
-
		rol				;-> a = $01 after first round
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits		;kills y
		bcc .lz_lrun_gotten

		asl .lz_bits
		bne -
		jsr .lz_refill_bits
		bne -

						;XXX code can be inserted here
.lz_lrun_gotten
		sta .lz_lcopy_len		;Store LSB of run-length
		ldy #$00
.lz_lcopy
.bitfire_lz_sector_ptr2	= * + 1			;Copy the literal data.
		lda $beef,x
		sta (.lz_dst),y
		inx
		bne *+5
		jsr .lz_next_page
		iny
.lz_lcopy_len = * + 1
		cpy #$00
		bne .lz_lcopy

		;Time to advance the destination pointer.
		;Maximum run length literals exit here as a type-bit needs
		;to be fetched afterwards
		tya
		beq .lz_maximum			;maximum literal run, bump sector pointers and so on and force new type bit
		clc
		adc .lz_dst
		sta .lz_dst
		bcc .lz_do_match
		inc .lz_dst+1

		;One literal run following another only makes sense if the
		;first run is of maximum length and had to be split. As that
		;case has been taken care of we can safely omit the type bit
		;here

						;XXX code can be inserted here if a bcs .lz_do_match is inserted before

		;******** Process match ********

		;check bit -> 1 -> short match (len 2)
		;else long match

.lz_do_match
		lda #$01			;this could be made shorter by using the last bitfetch of the upcoming loop and restoring the carry again by a cmp #$02. Saves bytes, but makes things slower, as eof check is also done with all short matches then

		asl .lz_bits			;first length bit (where a one identifies
		bne *+5				;a two-byte match)
		jsr .lz_refill_bits
		bcc .lz_get_offs		;all done, length is 2, skip further bitfetches (and eof check)
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol

		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		bcc -
!if BITFIRE_NO_OVERLAP = 0 {
		tay				;XXX TODO could this be placed elsewhere to make the tay obsolete?
		beq .lz_end_of_file		;A 257-byte (=>$00) run serves as a
}						;sentinel, but not with zero-overlap
.lz_get_offs
		sta .lz_mcopy_len		;store length at final destination
		lda #%11000000			;fetch 2 more prefix bits
		rol				;previous bit is still in carry \o/
-
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol
		bcs -

		beq .lz_far			;0 + 8 bits to fetch, branch out before table lookup to save a few cycles and one byte in the table
		tay
		lda .lz_lentab,y
-						;same as above
		asl .lz_bits
		bne *+5
		jsr .lz_refill_bits
		rol
		bcs -

		bmi .lz_short			;either 3,4,6 or 7 bits fetched -> highbyte will be $ff
.lz_far
		eor #$ff			;5 of 13, 2 of 10, 0 of 8 bits fetched as highbyte, lowbyte still to be fetched
		tay

.bitfire_lz_sector_ptr3	= * + 1
		lda $beef,x			;For large offsets we can load the
		inx				;low-byte straight from the stream
		bne .lz_join			;without going throught the shift
		jsr .lz_next_page		;register
		top
.lz_short
		ldy #$ff			;XXX TODO silly, y is set twice in short case
.lz_join
		adc .lz_dst			;subtract offset from lz_dst
		sta .lz_match
		tya				;hibyte
		adc .lz_dst+1
		sta .lz_match+1

		ldy #$ff			;The copy loop. This needs to be run
						;forwards since RLE-style matches can overlap the destination
.lz_mcopy
		iny
		lda (.lz_match),y		;copy one byte
		sta (.lz_dst),y
.lz_mcopy_len	= * + 1
		cpy #$ff
		bne .lz_mcopy

		tya				;advance destination pointer
;		sec
		adc .lz_dst
		sta .lz_dst

!if BITFIRE_NO_OVERLAP = 0 {
.lz_skip_poll	bcc .lz_poll
.lz_maximum	inc .lz_dst+1			;this is also used by maximum length
		bcs .lz_skip_end

} else {
		bcc .lz_end_low			;proceed to check

.lz_maximum
		inc .lz_dst+1			;advance hi byte
;		lda .lz_dst			;a = 0, so we would pass the following check only if the endadress is @ $xx00
						;if so, the endaddress can't be $xx00 and teh highbyt check will fail, as we just successfully wrote a literal with type bit, so teh end address must be greater then teh current lz_dst
.lz_end_low	eor #$00			;check end address
.lz_skip_poll	bne .lz_poll			;all okay, poll for a new block
		eor .lz_dst+1			;check highbyte
.lz_end_hi	eor #$00
		bne .lz_skip_end		;skip poll, so that only one branch needs to be manipulated
		jmp .lz_skip_fetch		;load any remaining literal blob if there, or exit with rts in case of plain decomp (rts there instead of php)
		;was .lz_pollloop
}

.lz_poll
		bit $dd00
		bvs .lz_skip_end

		stx .lz_match			;save x, lz_match is available at that moment
		jsr .pollblock			;yes, fetch another block and mark block in bitmap
		ldx .lz_match			;restore x
.lz_skip_end
						;literals needing an explicit type bit
		asl .lz_bits			;fetch next type bit
		jmp .lz_type_check

.lz_lentab = * - 1
		;short offset init values
		;!byte %00000000			;2
		!byte %11011111			;0
		!byte %11111011			;1
		!byte %10000000			;3

		;long offset init values
		!byte %11101111			;offset 0
		!byte %11111101			;offset 1
		!byte %10000000			;offset 2
		!byte %11110000			;offset 3

}	;endif DECOMP



!if BITFIRE_INCLUDE_FRAMEWORK = 1 {
link_decomp	= bitfire_decomp_
link_music_play
link_music_addr = * + 1
		jsr link_music_play_side1
		inc link_frame_count + 0
		bne +
		inc link_frame_count + 1
+
		rts
}

bitfire_resident_size = * - BITFIRE_RESIDENT_ADDR
}	;!zone resident
